#!/usr/dist/pkgs/perl,v5.003/5bin.sun4/perl

require 5.003;
BEGIN {
    my($workdir) = ($0 =~ /(.*)\/.*/);
    unshift(@INC,"$workdir/../lib");
}
my($workdir) = ($0 =~ /(.*)\/.*/);
use BER;
use SNMP_Session;
use SNMP_MIB;
use SNMP_Simple;
use Socket;
use strict;
#use Ping;

### MAIN ###

my($host) = "$ARGV[0]";
my(@hostip);
my($community) = "public";

$SNMP_Session::suppress_warnings = 1;
SNMP_MIB::loadoids("$workdir/../mibs", "RFC1213", "BRIDGE");
@hostip = gethostbyname($host);

$hostip[0] = inet_aton($hostip[0]);
my ($aip,$bip,$cip,$dip) = unpack('C4',$hostip[0]);
my $origaddr = "$aip.$bip.$cip.$dip";
my (@routers, @bridges);
my ($netmask, $physaddr, $physaddrstr, $physaddroid);

my $session = SNMP_Simple->open($host, $community, 161);
my ($netmaskstr, $interface) = $session->snmpget("ipAdEntNetMask.$origaddr",
						 "ipAdEntIfIndex.$origaddr");

if (defined($interface) && defined($netmaskstr)) {
    
    ($physaddr) = $session->snmpget("ifPhysAddress.$interface");
    
    if (defined($physaddr) && length($physaddr) > 0) { 
	my (@physaddrarr) = unpack('C6', $physaddr);
	$physaddrstr = sprintf("%02x:%02x:%02x:%02x:%02x:%02x", @physaddrarr);
	$physaddroid = sprintf("%d.%d.%d.%d.%d.%d", @physaddrarr);
    } else {
	$physaddrstr = "NA";
	$physaddroid = "";
    }
}

$session->close();
print "Tracing to $host, IP: $aip.$bip.$cip.$dip\n\tNetmask: $netmaskstr MAC: $physaddrstr\n";

$netmaskstr = "255.255.255.0" unless defined($netmaskstr);
$netmask = inet_aton($netmaskstr);
my ($invert) = inet_aton("255.255.255.254") ^ $netmask;
my ($minip) = $hostip[0] & $netmask;
my ($maxip) = $minip | $invert;
$minip = unpack('I', $minip);
$maxip = unpack('I', $maxip);

#my $ping = Ping->new("udp");
my $packedhost;
for ($packedhost=$minip+1; $packedhost <= $maxip; $packedhost++) {
    my ($tmp) = pack('I', $packedhost);
    my ($aip,$bip,$cip,$dip) = unpack('C4', pack('I', $packedhost));
    $host = "$aip.$bip.$cip.$dip";
    print "$aip.$bip.$cip.$dip";
    
    my $ping = system("/usr/sbin/ping $host 2 > /dev/null 2>&1");
#  if ($ping->ping($host)) {
    if ($ping == 0) {
	my $session = SNMP_Simple->open ($host, $community, 161);
	$session->{'session'}->{'retries'} = 1;
	my ($router, $services) = $session->snmpget('ipForwarding', 'sysServices');
	if (defined($router) && ($router == 1)) {
	    if (!(defined($physaddr) && length($physaddr) > 0)) {
		my ($netmaskstr, $interface) = $session->snmpget("ipAdEntNetMask.$host",
								 "ipAdEntIfIndex.$host");
		($physaddr) =
		    $session->snmpget("atPhysAddress.$interface.1.$origaddr");
		if (defined($physaddr) && length($physaddr) > 0) { 
		    my (@physaddrarr) = unpack('C6', $physaddr);
		    $physaddrstr = sprintf("%02x:%02x:%02x:%02x:%02x:%02x", @physaddrarr);
		    $physaddroid = sprintf("%d.%d.%d.%d.%d.%d", @physaddrarr);
		    print "\thas MAC $physaddrstr for host $origaddr";
		}
	    }
        }
	if (defined($services) && ($services & 2)) {
	    print "\tis a bridge";
	    push(@bridges, $host);
	}
	$session->close();
    }
    print "\n";
}

die "Must have a MAC address"
    unless (defined($physaddr) && length($physaddr) > 0);

my ($bridge);
foreach $bridge (@bridges) {
    my $session = SNMP_Simple->open ($bridge, $community, 161);
    $session->{'session'}->{'retries'} = 1;
    my($bridgeport) = $session->snmpget("dot1dTpFdbPort.$physaddroid");
    if (defined($bridgeport)) {
	my ($ifIndex) = $session->snmpget("dot1dBasePortIfIndex.$bridgeport");
	my ($ifDescr) = $session->snmpget("ifDescr.$ifIndex");
	print "\t$bridge has an entry for $physaddrstr on ";
	print "bridge port $bridgeport\n";
	print "\tinterface $ifIndex, description: $ifDescr\n";
	
	my (@entries) = $session->snmpgettable("dot1dTpFdbPort");
	my (%portcount, $i);
	foreach $i (@entries) {
	    if (defined($portcount{$i})) {
		$portcount{$i}++;
	    } else {
		$portcount{$i}=0;
	    }
	}
	if ($portcount{$bridgeport} > 0) {
	    print "There are other hosts on this port\n";
	}
    } else {
	print "\t$bridge does not have an entry for $physaddrstr\n"; 
    }    
    $session->close();
}

#$ping->close();


exit 0;
