#!/usr/dist/pkgs/perl,v5.003/5bin.sun4/perl
require 5.003;

BEGIN {
    my($workdir) = ($0 =~ /(.*)\/.*/);
    unshift(@INC,"$workdir/../lib");
}
my($workdir) = ($0 =~ /(.*)\/.*/);

use Socket;
use BER;
use SNMP_Session;
use SNMP_MIB;
use SNMP_Simple;
use strict;

my $query_string = $ARGV[0];

die "No query string" if (!defined ($query_string) || !$query_string);

my (%query) = (());
my ($hostname, $community);
if ($query_string =~ /.*@.*/) {
    ($community, $hostname) = split('@', $query_string, 3);
} else {
    $hostname = $query_string;
    $community = 'public';
}
SNMP_MIB::loadoids("$workdir/../mibs", "RFC1213");

my($session) = SNMP_Simple->open($hostname, $community);

die "Could not open SNMP session\n" unless defined $session;

my($sysDescr, $sysContact, $sysLocation, $sysName, $sysUpTime, 
   $sysObjectID) 
    =  $session->snmpget('sysDescr', 'sysContact', 'sysLocation', 
			 'sysName', 'sysUpTime', 'sysObjectID');

die "No SNMP response\n" unless defined $sysDescr;

$sysDescr =~ y/\r/\n/;
my($sysObjectName) = SNMP_MIB::oid2name($sysObjectID);

print <<EOF;
Name\t\t$sysName
Description\t$sysDescr
Contact\t$sysContact
Location\t$sysLocation
Uptime\t\t$sysUpTime
ObjectID\t$sysObjectID: $sysObjectName
EOF

print "\nTesting set of sysContact to 'nobody'\n";

my ($response);
$response = $session->snmpset('sysContact', 'string', 'nobody');
if ($response) {
    print "Set sysContact to $response\n";
    $response = $session->snmpset('sysContact', 'string', $sysContact);
    if ($response) {
	print "Set sysContact to $response\n";
    } else {
	print "$hostname did not let sysContact get changed back!\n";
    }
} else {
    print "$hostname did not respond to SNMP set\n";
}
exit 0;
